#include <stdio.h>
#include "stdlib.h"
#include <string.h>

/* print files in current directory in reverse order */
#include <dirent.h>

int j_filter(const struct dirent * dep) {
  // return strcmp("j", dep->d_name); /* select file names ge "j" */
  return dep->d_name[0] == 'j';	/* select files starting with 'j' */
}

int
main(void)
{
    struct dirent **namelist;
    int n;

   n = scandir(".", &namelist, j_filter, alphasort);
    if (n < 0)
        perror("scandir");
    else {
        while (n--) {
            printf("%s\n", namelist[n]->d_name);
            free(namelist[n]);
        }
        free(namelist);
    }
    exit (0);
}
