#include "stdio.h"
#include "stdlib.h"
#include "string.h"

double darray[] = { 16, 17, 3.14, -1.4, 4711, -666, 12.3 };
#define N_DARRAY (sizeof(darray)/sizeof(double))

int iarray[] =  { 16, 17, 3, -1, 4711, -666, 12, -347634786 };
#define N_IARRAY (sizeof(iarray)/sizeof(int))

char *sarray[] = {"ein", "paar", "schoene", "Strings", "fuer", "Papa",
		  " 007", "I'll be back ...", "It's raining again"};
#define N_SARRAY (sizeof(sarray)/sizeof(char *))

int compare_double (const void *x, const void *y) {
  return (int) (*(double *) x - *(double *) y);
}

int compare_int (const void *x, const void *y) {
  return (*(int *)x - *(int *)y);
}

int compare_str (const void *x, const void *y) {
  return strcmp (*(char **) x, *(char **) y);
}

void double_sort() {
  for (size_t i=0; i<N_DARRAY; i++) {
    printf ("%g\n", darray[i]);
  }
  printf ("**********\n");

  qsort (darray, N_DARRAY, sizeof(double), &compare_double);

  for (size_t i=0; i<N_DARRAY; i++) {
    printf ("%g\n", darray[i]);
  }
  printf ("**********\n");
}

void int_sort() {
  for (size_t i=0; i<N_IARRAY; i++) {
    printf ("%d\n", iarray[i]);
  }
  printf ("**********\n");

  qsort (iarray, N_IARRAY, sizeof(int), &compare_int);

  for (size_t i=0; i<N_IARRAY; i++) {
    printf ("%d\n", iarray[i]);
  }
  printf ("**********\n");
}

int main (int argc, char *argv[]) {
  for (size_t i=0; i<N_SARRAY; i++) {
    printf ("\"%s\"\n", sarray[i]);
  }
  printf ("**********\n");

  qsort (sarray, N_SARRAY, sizeof(char*), &compare_str);

  for (size_t i=0; i<N_SARRAY; i++) {
    printf ("\"%s\"\n", sarray[i]);
  }
  printf ("**********\n");

  return 0;
}
