#ifndef JSON_READER_H_
#define JSON_READER_H_

#include "stdbool.h"
#include "stdlib.h"

typedef struct reader reader;

bool parse_json (reader *input);
bool parse_element (reader *input);
bool parse_value (reader *input);
bool parse_object (reader *input);
bool parse_member (reader *input);
bool parse_string (reader *input);
bool parse_number (reader *input, int sign);
bool parse_array (reader *input);
bool parse_token (reader *input);

reader *make_reader (const char *stuff);

#endif
